unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, GLWin32Viewer, GLScene, GLObjects, GLCoordinates, GLCrossPlatform,
  BaseClasses, GLMesh, StdCtrls, VectorTypes, GLColor, GLState;

type
  TForm1 = class(TForm)
    GLScene1: TGLScene;
    GLCamera1: TGLCamera;
    GLLightSource1: TGLLightSource;
    GLDummyCube1: TGLDummyCube;
    GLSceneViewer1: TGLSceneViewer;
    GLMesh1: TGLMesh;
    Button1: TButton;
    procedure FormCreate(Sender: TObject);
    procedure GLSceneViewer1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormMouseWheelUp(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);
    procedure FormMouseWheelDown(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);
    procedure GLSceneViewer1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
    px,py : integer;
    ss    : single;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  ss := GLCamera1.SceneScale;
end;

procedure TForm1.FormMouseWheelDown(Sender: TObject; Shift: TShiftState;
  MousePos: TPoint; var Handled: Boolean);
begin
  ss := ss - 0.05;
  if (ss<0.2) then ss := 0.2;
  GLCamera1.SceneScale := ss;
end;

procedure TForm1.FormMouseWheelUp(Sender: TObject; Shift: TShiftState;
  MousePos: TPoint; var Handled: Boolean);
begin
  ss := ss + 0.05;
  if (ss>3) then ss := 3;
  GLCamera1.SceneScale := ss;
end;

procedure TForm1.GLSceneViewer1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  px := X; py := Y;
end;

procedure TForm1.GLSceneViewer1MouseMove(Sender: TObject;
  Shift: TShiftState;
  X, Y: Integer);
begin
  if ssLeft in Shift then begin
    GLCamera1.MoveAroundTarget(py-Y,px-X);
    px := X; py := Y;
  end;
end;

// ejemplos con un Mesh
procedure TForm1.Button1Click(Sender: TObject);
var
  nor, vec  : TVector3f;
begin
  GLMesh1.Vertices.Clear;

  nor[0] := 0; nor[1] := 0; nor[2] := 0;

  vec[0] := 0; vec[1] := 0; vec[2] := 0;
  GLMesh1.Vertices.AddVertex(vec,nor,clrYellow) ;
  vec[0] := 1; vec[1] := 0; vec[2] := 0;
  GLMesh1.Vertices.AddVertex(vec,nor,clrRed) ;
  vec[0] := 0; vec[1] := 1; vec[2] := 0;
  GLMesh1.Vertices.AddVertex(vec,nor,clrBlue) ;

  vec[0] := 0; vec[1] := 0; vec[2] := 0;
  GLMesh1.Vertices.AddVertex(vec,nor,clrGreen) ;
  vec[0] := 0; vec[1] := -0.5; vec[2] := 1;
  GLMesh1.Vertices.AddVertex(vec,nor,clrWhite) ;
  vec[0] := 1; vec[1] := 0; vec[2] := 0;
  GLMesh1.Vertices.AddVertex(vec,nor,clrRed) ;


  GLMesh1.CalcNormals(fwCounterClockWise);
end;



end.
